if select(2, UnitClass('player')) ~= "HUNTER" then
	DisableAddOn("AspectInspect")
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("AspectInspect")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");

AspectInspect.fonteffects = {
	["none"] = L["none"],
	["OUTLINE"] = L["OUTLINE"],
	["THICKOUTLINE"] = L["THICKOUTLINE"],
	["MONOCHROME"] = L["MONOCHROME"],
}

AspectInspect.msgoutputs = {
	["Seperate"] = L["Seperate"],
	["Error"] = L["Error"],
}

function AspectInspect:GetOptions()
	local options = { 
		name = "AspectInspect",
		handler = AspectInspect,
		type = "group",
		childGroups = "tree",
		args = {
			debug = {
				type = 'toggle',
				name = L["Debug mode"],
				desc = L["help_debug"],
				get = "getDebug",
				set = "setDebug",
				guiHidden = true,
				order = 1,
			},
			config = {
				type = 'execute',
				name = L["Configure Options"],
				desc = L["help_config"],
				func = "OpenConfig",
				guiHidden = true,
				order = 2,
			},
			lock = {
				type = 'toggle',
				name = L["Lock/Unlock"],
				desc = L["help_lock"],
				get = "getFramesMove",
				set = "setFramesMove",
				order = 3,
			},
			overlay = {
				type = 'toggle',
				name = L["Overlay"],
				desc = L["help_Overlay"],
				get = "getOverlay",
				set = "setOverlay",
				cmdHidden = true,
				order = 4,
			},
			iconfr = {
				type = 'toggle',
				name = L["Icon"],
				desc = L["help_Icon"],
				get = "getIcon",
				set = "setIcon",
				cmdHidden = true,
				order = 5,
			},
			version = {
				type = 'execute',
				name = L["Version"],
				desc = L["help_version"],
				func = "DisplayVersion",
				guiHidden = true,
				order = 100,
			},
			help = {
				type = 'description',
				name = L["help"],
				guiHidden = true,
				order = 99,
			},
			hideooc= {
				type = 'toggle',
				name = L["Hide out of combat"],
				desc = L["help_hideooc"],
				get = "getHideooc",
				set = "setHideooc",
				order = 1,
			},
			colours = {
				name = L["Overlay Frame"],
				type = 'group',
				order = 11,
				cmdHidden = true,
				args = {
					transaspect={
						type = 'range',
						min = 0,
						max = 1,
						name = L["Aspect Frame Alpha"],
						desc = L["coltransaspect"],
						get = "getAspectTrans",
						set = "setAspectTrans",
						order = 1,
					},
					transnoaspect={
						type = 'range',
						min = 0,
						max = 1,
						name = L["No Aspect Frame Alpha"],
						desc = L["coltransnoaspect"],
						get = "getNoAspectTrans",
						set = "setNoAspectTrans",
						order = 2,
					},
					dhawk = {
						type = 'color',
						name = L["Aspect of Dhawk Colour"],
						desc = L["colAspectDhawk"],
						get = "getAspectDhawkColour",
						set = "setAspectDhawkColour",
						hasAlpha = false,
						order = 3,
					},
					viper = {
						type = 'color',
						name = L["Aspect of Viper Colour"],
						desc = L["colAspectViper"],
						get = "getAspectViperColour",
						set = "setAspectViperColour",
						hasAlpha = false,
						order = 4,
					},
					hawk = {
						type = 'color',
						name = L["Aspect of Hawk Colour"],
						desc = L["colAspectHawk"],
						get = "getAspectHawkColour",
						set = "setAspectHawkColour",
						hasAlpha = false,
						order = 5,
					},
					monkey = {
						type = 'color',
						name = L["Aspect of Monkey Colour"],
						desc = L["colAspectMonkey"],
						get = "getAspectMonkeyColour",
						set = "setAspectMonkeyColour",
						hasAlpha = false,
						order = 6,
					},
					pack = {
						type = 'color',
						name = L["Aspect of Pack Colour"],
						desc = L["colAspectPack"],
						get = "getAspectPackColour",
						set = "setAspectPackColour",
						hasAlpha = false,
						order = 7,
					},
					cheetah = {
						type = 'color',
						name = L["Aspect of Cheetah Colour"],
						desc = L["colAspectCheetah"],
						get = "getAspectCheetahColour",
						set = "setAspectCheetahColour",
						hasAlpha = false,
						order = 8,
					},
					beast = {
						type = 'color',
						name = L["Aspect of Beast Colour"],
						desc = L["colAspectBeast"],
						get = "getAspectBeastColour",
						set = "setAspectBeastColour",
						hasAlpha = false,
						order = 9,
					},
					wild = {
						type = 'color',
						name = L["Aspect of Wild Colour"],
						desc = L["colAspectWild"],
						get = "getAspectWildColour",
						set = "setAspectWildColour",
						hasAlpha = false,
						order = 10,
					},
					noaspect = {
						type = 'color',
						name = L["No Aspect Colour"],
						desc = L["colNoAspect"],
						get = "getNoAspectColour",
						set = "setNoAspectColour",
						hasAlpha = false,
						order = 11,
					},
				},
			},
			icon = {
				name = L["Icon Frame"],
				type = 'group',
				order = 12,
				cmdHidden = true,
				args = {
					scaleicon={
						type = 'range',
						min = 0,
						max = 3,
						name = L["Icon Frame Scale"],
						desc = L["colscaleicon"],
						get = "getScale",
						set = "setScale",
						order = 1,
					},
					transicon={
						type = 'range',
						min = 0,
						max = 1,
						name = L["Icon Frame Alpha"],
						desc = L["coltransicon"],
						get = "getIconAlpha",
						set = "setIconAlpha",
						order = 2,
					},
				},
			},
			aspectwatch = {
				name = L["Aspectwatch"],
				desc = L["colAspectwatch"],
				type = "group",
				order = 13,
				cmdHidden = true,
				args = {
					pack = {
						type = "toggle",
						name = L["Packwatch"],
						desc = L["colPackwatch"],
						get = "getPackWarning",
						set = "setPackWarning",
					order = 1,
					},
					cheetah = {
						type = "toggle",
						name = L["Cheetahwatch"],
						desc = L["colCheetahwatch"],
						get = "getCheetahWarning",
						set = "setCheetahWarning",
						order = 2,
					},
					manalow={
						type = 'range',
						isPercent = true,
						bigStep = 0.05,
						min = 0,
						max = 1,
						name = L["Manalowwatchpercent"],
						desc = L["colManalowwatchpercent"],
						get = "getManaLow",
						set = "setManaLow",
						order = 3,
					},
					manahigh={
						type = 'range',
						isPercent = true,
						bigStep = 0.05,
						min = 0,
						max = 1,
						name = L["Manahighwatchpercent"],
						desc = L["colManahighwatchpercent"],
						get = "getManaHigh",
						set = "setManaHigh",
						order = 4,
					},
					mlowwarn = {
						type = "toggle",
						name = L["Manalowwatch"],
						desc = L["colManalowwatch"],
						get = "getMlowWarning",
						set = "setMlowWarning",
						order = 5,
					},
					mhighwarn = {
						type = "toggle",
						name = L["Manahighwatch"],
						desc = L["colManahighwatch"],
						get = "getMhighWarning",
						set = "setMhighWarning",
						order = 6,
					},
					sounds = {
						type = "toggle",
						name = L["Sound"],
						desc = L["colSoundalert"],
						get = "getSoundAlert",
						set = "setSoundAlert",
						order = 7,
					},
				},
			},
			mediaoptions = {
				name = L["Message"],
				desc = L["descMessage"],
				type = "group",
				order = 14,
				cmdHidden = true,
				args = {
					msgoutput = {
						type = 'select',
						name = L["msgoutput"],
						desc = L["colmsgoutput"],
						get = "GetMsgOutput",
						set = "SetMsgOutput",
						values = self.msgoutputs,
						order = 6,
					},				
					msgfont = {
						type = 'select',
						name = L["Message Font"],
						get = "GetMsgFont",
						set = "SetMsgFont",
						values = self.fonts,
						order = 7,
					},
					msgfontsize = {
						type = 'range',
						name = L["Message Font Size"],
						min = 6,
						max = 32,
						step = 1,
						get = "GetMsgFontSize",
						set = "SetMsgFontSize",
						order = 9,
					},
					msgfonteffect = {
						name = L["Message Font Effect"],
						type = "select",
						get = "GetMsgFontEffect",
						set = "SetMsgFontEffect",
						values = self.fonteffects,
						order = 8,
					},				
				},
			},
		},
	}
	return options
end

function AspectInspect:getDebug()
	return self.db.char.debug
end

function AspectInspect:setDebug()
	self.db.char.debug = not self.db.char.debug
	if (self.db.char.debug) then
		self:Print(L["config_debug_on"])
	else
		self:Print(L["config_debug_off"])
	end
end

function AspectInspect:getHideooc()
	return self.db.char.hideooc
end

function AspectInspect:setHideooc()
	self.db.char.hideooc = not self.db.char.hideooc
	if (self.db.char.hideooc) then
		self:Print(L["config_hideooc_on"])
		self.aspectframe:Hide()
	else
		self:Print(L["config_hideooc_off"])
		self.aspectframe:Show()
	end
end

function AspectInspect:getOverlay()
	return self.db.char.overlay
end

function AspectInspect:setOverlay()
	self.db.char.overlay = not self.db.char.overlay
	if (self.db.char.overlay) then
		self.aspectframe:Show()
	else
		self.aspectframe:Hide()
	end
end

function AspectInspect:getIcon()
	return self.db.char.icon
end

function AspectInspect:setIcon()
	self.db.char.icon = not self.db.char.icon
	if (self.db.char.icon) then
		self.iconframe:Show()
	else
		self.iconframe:Hide()
	end
end

function AspectInspect:FinishedMoving(var, frame)
	local point, relativeTo, relativePoint, xOffset, yOffset = frame:GetPoint();
	var.point = point
	var.relativeTo = relativeTo
	var.relativePoint = relativePoint
	var.xOffset = xOffset
	var.yOffset = yOffset
end

function AspectInspect:FinishedSizing(var, frame)
	local height = frame:GetHeight();
	local width = frame:GetWidth();
	var.width = width
	var.height = height
end

function AspectInspect:getScale()
    return self.db.char.iconframe.scale
end

function AspectInspect:setScale(info,newValue)
	self.db.char.iconframe.scale = newValue
	self.iconframe:SetScale(self.db.char.iconframe.scale)
end

function AspectInspect:OpenConfig()
	  if InterfaceOptionsFrame_OpenToCategory then
	    InterfaceOptionsFrame_OpenToCategory("AspectInspect");
    else
        InterfaceOptionsFrame_OpenToFrame("AspectInspect");
    end
end

function AspectInspect:DisplayVersion()
	self:Print(self.version)
end

function AspectInspect:getAspectHawkColour(info)
	local colours = self.db.char.colours.aspecthawk
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectHawkColour(info,r,g,b)
	self.db.char.colours.aspecthawk.r = r
	self.db.char.colours.aspecthawk.g = g
	self.db.char.colours.aspecthawk.b = b
end

function AspectInspect:getAspectDhawkColour(info)
	local colours = self.db.char.colours.aspectdhawk
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectDhawkColour(info,r,g,b)
	self.db.char.colours.aspectdhawk.r = r
	self.db.char.colours.aspectdhawk.g = g
	self.db.char.colours.aspectdhawk.b = b
end

function AspectInspect:getAspectViperColour(info)
	local colours = self.db.char.colours.aspectviper
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectViperColour(info,r,g,b)
	self.db.char.colours.aspectviper.r = r
	self.db.char.colours.aspectviper.g = g
	self.db.char.colours.aspectviper.b = b
end

function AspectInspect:getAspectMonkeyColour(info)
	local colours = self.db.char.colours.aspectmonkey
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectMonkeyColour(info,r,g,b)
	self.db.char.colours.aspectmonkey.r = r
	self.db.char.colours.aspectmonkey.g = g
	self.db.char.colours.aspectmonkey.b = b
end

function AspectInspect:getAspectCheetahColour(info)
	local colours = self.db.char.colours.aspectcheetah
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectCheetahColour(info,r,g,b)
	self.db.char.colours.aspectcheetah.r = r
	self.db.char.colours.aspectcheetah.g = g
	self.db.char.colours.aspectcheetah.b = b
end

function AspectInspect:getAspectPackColour(info)
	local colours = self.db.char.colours.aspectpack
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectPackColour(info,r,g,b)
	self.db.char.colours.aspectpack.r = r
	self.db.char.colours.aspectpack.g = g
	self.db.char.colours.aspectpack.b = b
end

function AspectInspect:getAspectWildColour(info)
	local colours = self.db.char.colours.aspectwild
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectWildColour(info,r,g,b)
	self.db.char.colours.aspectwild.r = r
	self.db.char.colours.aspectwild.g = g
	self.db.char.colours.aspectwild.b = b
end

function AspectInspect:getAspectBeastColour(info)
	local colours = self.db.char.colours.aspectbeast
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setAspectWildColour(info,r,g,b)
	self.db.char.colours.aspectwild.r = r
	self.db.char.colours.aspectwild.g = g
	self.db.char.colours.aspectwild.b = b
end

function AspectInspect:getNoAspectColour(info)
	local colours = self.db.char.colours.noaspect
	return colours.r, colours.g, colours.b, colours.a
end

function AspectInspect:setNoAspectColour(info,r,g,b)
	self.db.char.colours.noaspect.r = r
	self.db.char.colours.noaspect.g = g
	self.db.char.colours.noaspect.b = b
end

function AspectInspect:getAspectTrans(info)
	local colours = self.db.char.colours.aspectdhawk
	return colours.a
end

function AspectInspect:setAspectTrans(info,a)
	self.db.char.colours.aspecthawk.a = a
	self.db.char.colours.aspectdhawk.a = a
	self.db.char.colours.aspectmonkey.a = a
	self.db.char.colours.aspectviper.a = a
	self.db.char.colours.aspectwild.a = a
	self.db.char.colours.aspectpack.a = a
	self.db.char.colours.aspectcheetah.a = a
	self.db.char.colours.aspectbeast.a = a
end

function AspectInspect:getNoAspectTrans(info)
	local colours = self.db.char.colours.noaspect
	return colours.a
end

function AspectInspect:setNoAspectTrans(info,a)
	self.db.char.colours.noaspect.a = a

end

function AspectInspect:getIconAlpha(info)
    return self.db.char.iconframe.alpha
end

function AspectInspect:setIconAlpha(info, newValue)
	self.db.char.iconframe.alpha = newValue
	self.iconframe:SetAlpha(self.db.char.iconframe.alpha)
end

function AspectInspect:getPackWarning()
	return self.db.char.packwarning
end

function AspectInspect:setPackWarning()
	self.db.char.packwarning = not self.db.char.packwarning
	if (self.db.char.packwarning) then
		self:Print(L["config_pack_on"])
	else
		self:Print(L["config_pack_off"])
	end
end

function AspectInspect:getCheetahWarning()
	return self.db.char.cheetahwarning
end

function AspectInspect:setCheetahWarning()
	self.db.char.cheetahwarning = not self.db.char.cheetahwarning
	if (self.db.char.cheetahwarning) then
		self:Print(L["config_cheetah_on"])
	else
		self:Print(L["config_cheetah_off"])
	end
end

function AspectInspect:getMlowWarning()
	return self.db.char.manalowwarning
end

function AspectInspect:setMlowWarning()
	self.db.char.manalowwarning = not self.db.char.manalowwarning
	if (self.db.char.manalowwarning) then
		self:Print(L["config_manalow_on"])
	else
		self:Print(L["config_manalow_off"])
	end
end

function AspectInspect:getMhighWarning()
	return self.db.char.manahighwarning
end

function AspectInspect:setMhighWarning()
	self.db.char.manahighwarning = not self.db.char.manahighwarning
	if (self.db.char.manahighwarning) then
		self:Print(L["config_manahigh_on"])
	else
		self:Print(L["config_manahigh_off"])
	end
end

function AspectInspect:getSoundAlert()
	return self.db.char.soundalert
end

function AspectInspect:setSoundAlert()
	self.db.char.soundalert = not self.db.char.soundalert
	if (self.db.char.soundalert) then
		self:Print(L["config_sound_on"])
	else
		self:Print(L["config_sound_off"])
	end
end

function AspectInspect:getManaLow(info)
	return self.db.char.manalowscale
end

function AspectInspect:setManaLow(info, new_value)
	self.db.char.manalowscale = new_value
end

function AspectInspect:getManaHigh(info)
	return self.db.char.manahighscale
end

function AspectInspect:setManaHigh(info, new_value)
	self.db.char.manahighscale = new_value
end

function AspectInspect:getFramesMove()
	return self.db.char.framesMoving
end

function AspectInspect:setFramesMove()
	self.db.char.framesMoving = not self.db.char.framesMoving
		if (self.db.char.framesMoving) then
		self:FrameLock(self.aspectframe)
		self:FrameLock(self.msgframe)
		self:FrameLock(self.iconframe)
		self.aspectframe.Grip:Show()
		self.msgframe.Grip:Show()
		self.iconframe:SetAlpha(1)
	else
		self:FrameUnlock(self.aspectframe)
		self:FrameUnlock(self.msgframe)
		self:FrameUnlock(self.iconframe)
		self.aspectframe.Grip:Hide()
		self.msgframe.Grip:Hide()
		self.iconframe:SetAlpha(0.5)
	end
end

function AspectInspect:GetMsgFont()
    return self.db.char.msgfont
end

function AspectInspect:GetMsgOutput()
    return self.db.char.msgoutput
end

function AspectInspect:GetMsgFontSize()
    return self.db.char.msgfontsize
end

function AspectInspect:GetMsgFontEffect()
    return self.db.char.msgfonteffect
end

function AspectInspect:SetMsgFont(info, newValue)
	self.db.char.msgfont = newValue
end

function AspectInspect:SetMsgOutput(info, newValue)
	self.db.char.msgoutput = newValue
end

function AspectInspect:SetMsgFontSize(info, newValue)
	self.db.char.msgfontsize = newValue
end

function AspectInspect:SetMsgFontEffect(info, newValue)
	self.db.char.msgfonteffect = newValue
end